/**
 * @name string-remove-duplicate-heads-tails
 * @fileoverview Detect and (recursively) remove head and tail wrappings around the input string
 * @version 7.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-remove-duplicate-heads-tails/}
 */

"use strict";var stringRemoveDuplicateHeadsTails=(()=>{var _=Object.defineProperty;var Y=Object.getOwnPropertyDescriptor;var ee=Object.getOwnPropertyNames,H=Object.getOwnPropertySymbols;var W=Object.prototype.hasOwnProperty,re=Object.prototype.propertyIsEnumerable;var x=(e,i,s)=>i in e?_(e,i,{enumerable:!0,configurable:!0,writable:!0,value:s}):e[i]=s,$=(e,i)=>{for(var s in i||(i={}))W.call(i,s)&&x(e,s,i[s]);if(H)for(var s of H(i))re.call(i,s)&&x(e,s,i[s]);return e};var te=(e,i)=>{for(var s in i)_(e,s,{get:i[s],enumerable:!0})},ne=(e,i,s,n)=>{if(i&&typeof i=="object"||typeof i=="function")for(let l of ee(i))!W.call(e,l)&&l!==s&&_(e,l,{get:()=>i[l],enumerable:!(n=Y(i,l))||n.enumerable});return e};var ie=e=>ne(_({},"__esModule",{value:!0}),e);var J=(e,i,s)=>(x(e,typeof i!="symbol"?i+"":i,s),s);var pe={};te(pe,{defaults:()=>Z,remDup:()=>me,version:()=>fe});function v(e){if(e==null||typeof e!="object")return!1;let i=Object.getPrototypeOf(e);return i!==null&&i!==Object.prototype&&Object.getPrototypeOf(i)!==null?!1:!(Symbol.iterator in e)&&!(Symbol.toStringTag in e)}function D(e){return typeof e=="string"}function M(e){return Number.isSafeInteger(e)&&e>=0}function A(e){return e!=null}function L(e,i){return v(e)&&D(i)&&Object.prototype.hasOwnProperty.call(e,i)}function N(e){return typeof e!="string"?e:e.length?[e]:[]}var j={cb:void 0,i:!1,trimBeforeMatching:!1,trimCharsBeforeMatching:[],maxMismatches:0,firstMustMatch:!1,lastMustMatch:!1,hungry:!1},se=e=>e+1;function ae(e,i,s,n,l=!1,r=se){let o=typeof s=="function"?s():s;if(+i<0&&l&&o==="EOL")return o;let a=$($({},j),n);if(i>=e.length&&!l)return!1;let u=l?1:s.length,t=0,f=!1,d=!1,m=!1,g=a.maxMismatches,c=i,h=!1,y=!1,p=!1;function O(){return t===1&&g<a.maxMismatches-1}for(;e[c];){let b=r(c);if(a.trimBeforeMatching&&e[c].trim()===""){if(!e[b]&&l&&s==="EOL")return!0;c=r(c);continue}if(a&&!a.i&&a.trimCharsBeforeMatching&&a.trimCharsBeforeMatching.includes(e[c])||a!=null&&a.i&&a.trimCharsBeforeMatching&&a.trimCharsBeforeMatching.map(E=>E.toLowerCase()).includes(e[c].toLowerCase())){if(l&&s==="EOL"&&!e[b])return!0;c=r(c);continue}let w=b>c?s[s.length-u]:s[u-1];if(!a.i&&e[c]===w||a.i&&e[c].toLowerCase()===w.toLowerCase()){if(h||(h=!0),m||(m=!0),u===s.length){if(y=!0,g!==a.maxMismatches)return!1}else u===1&&(p=!0);if(u-=1,t++,O())return!1;if(!u)return t!==s.length||g===a.maxMismatches||!f?c:!1}else if(!f&&!t&&(f=!0),a.maxMismatches&&g&&c){g-=1;for(let E=0;E<=g;E++){let T=b>c?s[s.length-u+1+E]:s[u-2-E],C=e[r(c)];if(T&&(!a.i&&e[c]===T||a.i&&e[c].toLowerCase()===T.toLowerCase())&&(!a.firstMustMatch||u!==s.length)){if(t++,O())return!1;u-=2,h=!0;break}else if(C&&T&&(!a.i&&C===T||a.i&&C.toLowerCase()===T.toLowerCase())&&(!a.firstMustMatch||u!==s.length)){if(!t&&!a.hungry)return!1;u-=1,h=!0;break}else if(T===void 0&&g>=0&&h&&(!a.firstMustMatch||y)&&(!a.lastMustMatch||p))return c}h||(d=c)}else return c===0&&u===1&&!a.lastMustMatch&&m?0:!1;if(d!==!1&&d!==c&&(d=!1),u<1)return c;c=r(c)}if(u>0)return l&&o==="EOL"?!0:a&&a.maxMismatches>=u&&m?d||0:!1}function q(e,i,s,n,l){var f,d;if(v(l)&&L(l,"trimBeforeMatching")&&l&&typeof l.trimBeforeMatching!="boolean")throw new Error(`string-match-left-right/${e}(): [THROW_ID_09] opts.trimBeforeMatching should be boolean!${Array.isArray(l.trimBeforeMatching)?" Did you mean to use opts.trimCharsBeforeMatching?":""}`);let r=$($({},j),l);if(typeof r.trimCharsBeforeMatching=="string"&&(r.trimCharsBeforeMatching=N(r.trimCharsBeforeMatching)),r.trimCharsBeforeMatching=r.trimCharsBeforeMatching.map(m=>D(m)?m:String(m)),!D(i)||!i.length)return!1;if(!Number.isInteger(s)||s<0)throw new Error(`string-match-left-right/${e}(): [THROW_ID_03] the second argument should be a natural number. Currently it's of a type: ${typeof s}, equal to:
${JSON.stringify(s,null,4)}`);let o,a;if(D(n))o=[n];else if(Array.isArray(n))o=n;else if(!n)o=n;else if(typeof n=="function")o=[],o.push(n);else throw new Error(`string-match-left-right/${e}(): [THROW_ID_05] the third argument, whatToMatch, is neither string nor array of strings! It's ${typeof n}, equal to:
${JSON.stringify(n,null,4)}`);if(l&&!v(l))throw new Error(`string-match-left-right/${e}(): [THROW_ID_06] the fourth argument, options object, should be a plain object. Currently it's of a type "${typeof l}", and equal to:
${JSON.stringify(l,null,4)}`);let u=0,t="";if(r!=null&&r.trimCharsBeforeMatching&&r.trimCharsBeforeMatching.some((m,g)=>m.length>1?(u=g,t=m,!0):!1))throw new Error(`string-match-left-right/${e}(): [THROW_ID_07] the fourth argument, options object contains trimCharsBeforeMatching. It was meant to list the single characters but one of the entries at index ${u} is longer than 1 character, ${t.length} (equals to ${t}). Please split it into separate characters and put into array as separate elements.`);if(!o||!Array.isArray(o)||Array.isArray(o)&&!o.length||Array.isArray(o)&&o.length===1&&D(o[0])&&!o[0].trim()){if(typeof r.cb=="function"){let g,c=s;if((e==="matchLeftIncl"||e==="matchRight")&&(c+=1),e[5]==="L")for(let O=c;O--;){let b=i[O];if((!r.trimBeforeMatching||r.trimBeforeMatching&&b!==void 0&&b.trim())&&(!((f=r.trimCharsBeforeMatching)!=null&&f.length)||b!==void 0&&!r.trimCharsBeforeMatching.includes(b))){g=O;break}}else if(e.startsWith("matchRight"))for(let O=c;O<i.length;O++){let b=i[O];if((!r.trimBeforeMatching||r.trimBeforeMatching&&b.trim())&&(!((d=r.trimCharsBeforeMatching)!=null&&d.length)||!r.trimCharsBeforeMatching.includes(b))){g=O;break}}if(g===void 0)return!1;let h=i[g],y=g+1,p="";return y&&y>0&&(p=i.slice(0,y)),e[5]==="L"||g&&g>0&&(p=i.slice(g)),r.cb(h,p,g)}let m="";throw l||(m=" More so, the whole options object, the fourth input argument, is missing!"),new Error(`string-match-left-right/${e}(): [THROW_ID_08] the third argument, "whatToMatch", was given as an empty string. This means, you intend to match purely by a callback. The callback was not set though, the opts key "cb" is not set!${m}`)}for(let m=0,g=o.length;m<g;m++){a=typeof o[m]=="function";let c=o[m],h,y,p="",O=s;e==="matchRight"?O+=1:e==="matchLeft"&&(O-=1);let b=ae(i,O,c,r,a,w=>e[5]==="L"?w-1:w+1);if(b&&a&&typeof c=="function"&&c()==="EOL")return c()&&(!r.cb||r.cb(h,p,y))?c():!1;if(Number.isInteger(b)&&(y=e.startsWith("matchLeft")?b-1:b+1,e[5]==="L"?p=i.slice(0,b):p=i.slice(y)),y<0&&(y=void 0),i[y]&&(h=i[y]),Number.isInteger(b)&&(!r.cb||r.cb(h,p,y)))return c}return!1}function k(e,i,s,n){return q("matchLeftIncl",e,i,s,n)}function I(e,i,s,n){return q("matchRightIncl",e,i,s,n)}function F(e,i=1){let s="\xA0";function n(r){return Array.from(r).reverse().join("")}function l(r,o,a){let u=a?`
`:"\r",t=a?"\r":`
`;if(!r)return r;let f=0,d=0,m="";for(let g=0,c=r.length;g<c;g++)(r[g]===u||r[g]===t&&r[g-1]!==u)&&d++,`\r
`.includes(r[g])||r[g]===s?(f=0,r[g]===s?m+=r[g]:r[g]===u?d<=o&&(m+=r[g],r[g+1]===t&&(m+=r[g+1],g++)):r[g]===t&&(r==null?void 0:r[g-1])!==u&&d<=o&&(m+=r[g])):(f++,!r[g+1]&&!d&&(m+=" "));return m}if(typeof e=="string"&&e.length){let r=1;typeof+i=="number"&&Number.isInteger(+i)&&+i>=0&&(r=+i);let o="",a="";if(!e.trim())o=e;else if(!e[0].trim()){for(let u=0,t=e.length;u<t;u++)if(e[u].trim()){o=e.slice(0,u);break}}if(e.trim()&&(e.slice(-1).trim()===""||e.slice(-1)===s)){for(let u=e.length;u--;)if(e[u].trim()){a=e.slice(u+1);break}}return`${l(o,r,!1)}${e.trim()}${n(l(n(a),r,!0))}`}return e}var oe={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function R(e,i){if(!Array.isArray(e)||!e.length)return e;let s=$($({},oe),i),n,l;if(s.strictlyTwoElementsInRangeArrays&&!e.every((a,u)=>!Array.isArray(a)||a.length!==2?(n=u,l=a.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) has not two but ${l} elements!`);if(!e.every((a,u)=>!Array.isArray(a)||!Number.isInteger(a[0])||a[0]<0||!Number.isInteger(a[1])||a[1]<0?(n=u,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${n}th range (${JSON.stringify(e[n],null,4)}) does not consist of only natural numbers!`);let r=e.length**2,o=0;return Array.from(e).sort((a,u)=>(s.progressFn&&(o+=1,s.progressFn(Math.floor(o*100/r))),a[0]===u[0]?a[1]<u[1]?-1:a[1]>u[1]?1:0:a[0]<u[0]?-1:1))}var P={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function le(e,i){function s(t){return!!t&&typeof t=="object"&&!Array.isArray(t)}if(!Array.isArray(e)||!e.length)return null;let n;if(i)if(s(i)){if(n=$($({},P),i),n.progressFn&&s(n.progressFn)&&!Object.keys(n.progressFn).length)n.progressFn=null;else if(n.progressFn&&typeof n.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn,null,4)}`);if(![1,2,"1","2"].includes(n.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType,null,4)}`);if(typeof n.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(i,null,4)} (type ${typeof i})`);else n=$({},P);let l=e.filter(t=>Array.isArray(t)).map(t=>[...t]).filter(t=>t[2]!==void 0||t[0]!==t[1]),r,o,a;n.progressFn?r=R(l,{progressFn:t=>{a=Math.floor(t/5),a!==o&&(o=a,n.progressFn(a))}}):r=R(l);let u=r.length-1;for(let t=u;t>0;t--)n.progressFn&&(a=Math.floor((1-t/u)*78)+21,a!==o&&a>o&&(o=a,n.progressFn(a))),(r[t][0]<=r[t-1][0]||!n.joinRangesThatTouchEdges&&r[t][0]<r[t-1][1]||n.joinRangesThatTouchEdges&&r[t][0]<=r[t-1][1])&&(r[t-1][0]=Math.min(r[t][0],r[t-1][0]),r[t-1][1]=Math.max(r[t][1],r[t-1][1]),r[t][2]!==void 0&&(r[t-1][0]>=r[t][0]||r[t-1][1]<=r[t][1])&&r[t-1][2]!==null&&(r[t][2]===null&&r[t-1][2]!==null?r[t-1][2]=null:r[t-1][2]!=null?+n.mergeType==2&&r[t-1][0]===r[t][0]?r[t-1][2]=r[t][2]:r[t-1][2]+=r[t][2]:r[t-1][2]=r[t][2]),r.splice(t,1),t=r.length);return r.length?r:null}var ue={limitToBeAddedWhitespace:!1,limitLinebreaksCount:1,mergeType:1},V=class{constructor(e){J(this,"ranges");J(this,"opts");let i=$($({},ue),e);if(i.mergeType&&i.mergeType!==1&&i.mergeType!==2)if(D(i.mergeType)&&i.mergeType.trim()==="1")i.mergeType=1;else if(D(i.mergeType)&&i.mergeType.trim()==="2")i.mergeType=2;else throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof i.mergeType}", equal to ${JSON.stringify(i.mergeType,null,4)}`);this.opts=i,this.ranges=[]}add(e,i,s){var r;if(e==null&&i==null)return;if(A(e)&&!A(i)){if(Array.isArray(e)){if(e.length){if(e.some(o=>Array.isArray(o))){e.forEach(o=>{Array.isArray(o)&&this.add(...o)});return}e.length&&M(+e[0])&&M(+e[1])&&this.add(...e)}return}throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(e,null,0)}) but second-one, "to" is not (${JSON.stringify(i,null,0)})`)}else if(!A(e)&&A(i))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(i,null,0)}) but first-one, "from" is not (${JSON.stringify(e,null,0)})`);let n=+e,l=+i;if(M(s)&&(s=String(s)),M(n)&&M(l)){if(A(s)&&!D(s)&&!M(s))throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof s}, equal to:
${JSON.stringify(s,null,4)}`);if(A(this.ranges)&&Array.isArray(this.last())&&n===this.last()[1]){if(this.last()[1]=l,this.last()[2],this.last()[2]!==null&&A(s)){let o=this.last()[2]&&this.last()[2].length&&(!((r=this.opts)!=null&&r.mergeType)||this.opts.mergeType===1)?`${this.last()[2]}${s}`:s;this.opts.limitToBeAddedWhitespace&&(o=F(o,this.opts.limitLinebreaksCount)),D(o)&&!o.length||(this.last()[2]=o)}}else{this.ranges||(this.ranges=[]);let o=s!==void 0&&!(D(s)&&!s.length)?[n,l,s&&this.opts.limitToBeAddedWhitespace?F(s,this.opts.limitLinebreaksCount):s]:[n,l];this.ranges.push(o)}}else throw M(n)&&n>=0?new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof l}" equal to: ${JSON.stringify(l,null,4)}`):new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof n}" equal to: ${JSON.stringify(n,null,4)}`)}push(e,i,s){this.add(e,i,s)}current(){return Array.isArray(this.ranges)&&this.ranges.length?(this.ranges=le(this.ranges,{mergeType:this.opts.mergeType}),this.ranges&&this.opts.limitToBeAddedWhitespace?this.ranges.map(e=>A(e[2])?[e[0],e[1],F(e[2],this.opts.limitLinebreaksCount)]:e):this.ranges):null}wipe(){this.ranges=[]}replace(e){if(Array.isArray(e)&&e.length)if(Array.isArray(e[0])&&M(e[0][0]))this.ranges=Array.from(e);else throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(e[0],null,4)} should be an array and its first element should be an integer, a string index.`);else this.ranges=[]}last(){return Array.isArray(this.ranges)&&this.ranges.length?this.ranges[this.ranges.length-1]:null}};var U={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function Q(e,i){function s(t){return!!t&&typeof t=="object"&&!Array.isArray(t)}if(!Array.isArray(e)||!e.length)return null;let n;if(i)if(s(i)){if(n=$($({},U),i),n.progressFn&&s(n.progressFn)&&!Object.keys(n.progressFn).length)n.progressFn=null;else if(n.progressFn&&typeof n.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn,null,4)}`);if(![1,2,"1","2"].includes(n.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType,null,4)}`);if(typeof n.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(i,null,4)} (type ${typeof i})`);else n=$({},U);let l=e.filter(t=>Array.isArray(t)).map(t=>[...t]).filter(t=>t[2]!==void 0||t[0]!==t[1]),r,o,a;n.progressFn?r=R(l,{progressFn:t=>{a=Math.floor(t/5),a!==o&&(o=a,n.progressFn(a))}}):r=R(l);let u=r.length-1;for(let t=u;t>0;t--)n.progressFn&&(a=Math.floor((1-t/u)*78)+21,a!==o&&a>o&&(o=a,n.progressFn(a))),(r[t][0]<=r[t-1][0]||!n.joinRangesThatTouchEdges&&r[t][0]<r[t-1][1]||n.joinRangesThatTouchEdges&&r[t][0]<=r[t-1][1])&&(r[t-1][0]=Math.min(r[t][0],r[t-1][0]),r[t-1][1]=Math.max(r[t][1],r[t-1][1]),r[t][2]!==void 0&&(r[t-1][0]>=r[t][0]||r[t-1][1]<=r[t][1])&&r[t-1][2]!==null&&(r[t][2]===null&&r[t-1][2]!==null?r[t-1][2]=null:r[t-1][2]!=null?+n.mergeType==2&&r[t-1][0]===r[t][0]?r[t-1][2]=r[t][2]:r[t-1][2]+=r[t][2]:r[t-1][2]=r[t][2]),r.splice(t,1),t=r.length);return r.length?r:null}var ge=!0,B="Invariant failed";function G(e,i){if(!e){if(ge)throw new Error(B);var s=typeof i=="function"?i():i,n=s?"".concat(B,": ").concat(s):B;throw new Error(n)}}function z(e,i,s){let n=0,l=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof e!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof e}, equal to: ${JSON.stringify(e,null,4)}`);if(i&&!Array.isArray(i))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof i}, equal to: ${JSON.stringify(i,null,4)}`);if(s&&typeof s!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof s}, equal to: ${JSON.stringify(s,null,4)}`);if(!i||!i.filter(f=>f).length)return e;let r;Array.isArray(i)&&Number.isInteger(i[0])&&Number.isInteger(i[1])?r=[Array.from(i)]:r=Array.from(i);let o=r.length,a=0;r.filter(f=>f).forEach((f,d)=>{if(s&&(n=Math.floor(a/o*10),n!==l&&(l=n,s(n))),!Array.isArray(f))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${d}th element not an array: ${JSON.stringify(f,null,4)}, which is ${typeof f}`);if(!Number.isInteger(f[0])){if(!Number.isInteger(+f[0])||+f[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${d}th element, array ${JSON.stringify(f,null,0)}. Its first element is not an integer, string index, but ${typeof f[0]}, equal to: ${JSON.stringify(f[0],null,4)}.`);r[d][0]=+r[d][0]}if(!Number.isInteger(f[1])){if(!Number.isInteger(+f[1])||+f[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${d}th element, array ${JSON.stringify(f,null,0)}. Its second element is not an integer, string index, but ${typeof f[1]}, equal to: ${JSON.stringify(f[1],null,4)}.`);r[d][1]=+r[d][1]}a+=1});let u=Q(r,{progressFn:f=>{s&&(n=10+Math.floor(f/10),n!==l&&(l=n,s(n)))}});G(u);let t=u.length;if(t>0){let f=e.slice(u[t-1][1]);e=u.reduce((d,m,g,c)=>{s&&(n=20+Math.floor(g/t*80),n!==l&&(l=n,s(n)));let h=g===0?0:c[g-1][1],y=c[g][0];return`${d}${e.slice(h,y)}${c[g][2]||""}`},""),e+=f}return e}var he={classicTrim:!1,cr:!1,lf:!1,tab:!1,space:!0,nbsp:!1};function S(e,i){if(typeof e!="string")throw new Error(`string-trim-spaces-only: [THROW_ID_01] input must be string! It was given as ${typeof e}, equal to:
${JSON.stringify(e,null,4)}`);let s=$($({},he),i);function n(o){return s.classicTrim&&!o.trim()||!s.classicTrim&&(s.space&&o===" "||s.cr&&o==="\r"||s.lf&&o===`
`||s.tab&&o==="	"||s.nbsp&&o==="\xA0")}let l,r;if(e.length){if(n(e[0]))for(let o=0,a=e.length;o<a;o++){if(!n(e[o])){l=o;break}if(o===e.length-1)return{res:"",ranges:[[0,e.length]]}}if(n(e[e.length-1])){for(let o=e.length;o--;)if(!n(e[o])){r=o+1;break}}return l?r?{res:e.slice(l,r),ranges:[[0,l],[r,e.length]]}:{res:e.slice(l),ranges:[[0,l]]}:r?{res:e.slice(0,r),ranges:[[r,e.length]]}:{res:e,ranges:[]}}return{res:"",ranges:[]}}var K="7.0.10";var fe=K,Z={heads:["{{"],tails:["}}"]};function me(e,i){let s=Object.prototype.hasOwnProperty;if(e===void 0)throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_01] The input is missing!");if(typeof e!="string")return e;if(i&&!v(i))throw new Error(`string-remove-duplicate-heads-tails: [THROW_ID_03] The given options are not a plain object but ${typeof i}!`);let n=$({},i);if(n&&s.call(n,"heads"))if(N(n.heads).every(h=>typeof h=="string"||Array.isArray(h)))typeof n.heads=="string"&&(n.heads=N(n.heads));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_04] The resolvedOpts.heads contains elements which are not string-type!");if(n&&s.call(n,"tails"))if(N(n.tails).every(h=>typeof h=="string"||Array.isArray(h)))typeof n.tails=="string"&&(n.tails=N(n.tails));else throw new Error("string-remove-duplicate-heads-tails: [THROW_ID_05] The resolvedOpts.tails contains elements which are not string-type!");let l=S(e).res;if(l.length===0)return e;e=l;let r=$($({},Z),n);r.heads=r.heads.map(h=>h.trim()),r.tails=r.tails.map(h=>h.trim());let o=!1,a=!1,u=new V({limitToBeAddedWhitespace:!0}),t=new V({limitToBeAddedWhitespace:!0}),f=!0,d=!0,m="";function g(h,y){let p;return I(h,0,y.heads,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})&&I(h,p,y.tails,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})?h.slice(p):h}for(;e!==g(e,r);)e=S(g(e,r)).res;function c(h,y){let p;return!k(h,h.length-1,y.tails,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})||!p?h:k(h,p,y.heads,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})?h.slice(0,p+1):h}for(;e!==c(e,r);)e=S(c(e,r)).res;if(!r.heads.length||!I(e,0,r.heads,{trimBeforeMatching:!0})||!r.tails.length||!k(e,e.length-1,r.tails,{trimBeforeMatching:!0}))return S(e).res;for(let h=0,y=e.length;h<y;h++)if(e[h].trim()!==""){let p;if(I(e,h,r.heads,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=T,!0)})&&p){d=!0,f&&(f=!0);let w;I(e,p,r.tails,{trimBeforeMatching:!0,cb:(T,C,X)=>(w=X,!0)})&&u.push(h,w),t.current()&&o&&m!=="tails"&&u.push(t.current()),o||t.current()&&(u.push(t.current()),t.wipe()),t.push(h,p),m="heads",h=p-1;continue}if(I(e,h,r.tails,{trimBeforeMatching:!0,cb:(w,E,T)=>(p=Number.isInteger(T)?T:e.length,!0)})&&p){d=!0,f?(m==="heads"&&t.wipe(),f=!1):t.push(h,p),m="tails",h=p-1;continue}f&&(f=!0),d&&!o?(o=!0,d=!1):d&&!a?(a=!0,f=!0,d=!1,m==="heads"&&t.wipe()):d&&a&&t.wipe()}return t.current()&&u.push(t.current()),u.current()?z(e,u.current()).trim():e.trim()}return ie(pe);})();
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.3.1
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
/**
 * @name arrayiffy-if-string
 * @fileoverview Put non-empty strings into arrays, turn empty-ones into empty arrays. Bypass everything else.
 * @version 5.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/arrayiffy-if-string/}
 */
/**
 * @name string-match-left-right
 * @fileoverview Match substrings on the left or right of a given index, ignoring whitespace
 * @version 9.0.10
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-match-left-right/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.5
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name string-trim-spaces-only
 * @fileoverview Like String.trim() but you can choose granularly what to trim
 * @version 5.0.7
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-trim-spaces-only/}
 */
